package sca.component.mediation.java;

import com.ibm.iif.mediation.PropertyLoader;
import commonj.sdo.DataObject;
import com.ibm.websphere.sca.ServiceManager;
import javax.xml.namespace.QName;
import com.ibm.websphere.sibx.smobo.ServiceMessageObjectFactory;
import com.ibm.websphere.sibx.smobo.ServiceMessageObject;
import com.ibm.websphere.bo.BOFactory;
import java.util.Vector;
import java.util.List;
import com.ibm.wsspi.sibx.mediation.InputTerminal;
import com.ibm.wsspi.sibx.mediation.MediationBusinessException;
import com.ibm.wsspi.sibx.mediation.MediationConfigurationException;
import com.ibm.wsspi.sibx.mediation.OutputTerminal;
import com.ibm.wsspi.sibx.mediation.esb.ESBMediationPrimitive;
import com.ibm.wsspi.sibx.mediation.MediationServices;

/**
 * @generated
 *  Flow: IndFrwksHSDAMediation_MSSQL Interface: IIFMAHSDAAdapter Operation: getListOfItemIds Type: response Custom Mediation: CustomMediation1
 */
public class Custom1281097418812 extends ESBMediationPrimitive {

	private InputTerminal in;
	private OutputTerminal out;

	/* state of primitive initialization */
	private boolean __initPassed = false;

	/* primitive display name */
	private String __primitiveDisplayName = null;

	/* 
	 * @generated
	 * (non-Javadoc)
	 * @see com.ibm.wsspi.sibx.mediation.Mediation#init()
	 */
	public void init() throws MediationConfigurationException {
		/* Get the mediation service */
		MediationServices mediationServices = this.getMediationServices();
		if (mediationServices == null)
			throw new MediationConfigurationException(
					"MediationServices object not set.");

		/* Get the primitive display name for use in exception messages */
		__primitiveDisplayName = mediationServices.getMediationDisplayName();

		in = mediationServices.getInputTerminal("in");
		if (in == null) {
			throw new MediationConfigurationException(
					"No terminal named in defined for mediation primitive "
							+ __primitiveDisplayName);
		}

		out = mediationServices.getOutputTerminal("out");
		if (out == null) {
			throw new MediationConfigurationException(
					"No terminal named out defined for mediation primitive "
							+ __primitiveDisplayName);
		}

		/* Initialization completed */
		__initPassed = true;
	}

	/* 
	 * @generated
	 * (non-Javadoc)
	 * @see com.ibm.wsspi.sibx.mediation.Mediation#mediate(com.ibm.wsspi.sibx.mediation.InputTerminal, commonj.sdo.DataObject)
	 */
	public void mediate(InputTerminal inputTerminal, DataObject message)
			throws MediationConfigurationException, MediationBusinessException {
		/* If initialization didn't complete, try again */
		if (!__initPassed) {
			init();
		}

		try {
			doMediate(inputTerminal, (ServiceMessageObject) message);
		} catch (Exception e) {
			if (e instanceof MediationBusinessException) {
				throw (MediationBusinessException) e;
			} else if (e instanceof MediationConfigurationException) {
				throw (MediationConfigurationException) e;
			} else {
				throw new MediationBusinessException(e);
			}
		}
	}

	/**
	 * @generated
	 */
	public void doMediate(InputTerminal inputTerminal, ServiceMessageObject smo)
			throws MediationConfigurationException, MediationBusinessException {
		/**
		 * GENERATED COMMENT - DO NOT MODIFY
		 * Variables:  for output terminals - out (com.ibm.wsspi.sibx.mediation.OutputTerminal)
		 *             for user properties - <No user properties defined>
		 * Inputs:     inputTerminal (com.ibm.wsspi.sibx.mediation.InputTerminal), smo (com.ibm.websphere.sibx.smobo.ServiceMessageObject)
		 * Exceptions: com.ibm.wsspi.sibx.mediation.MediationConfigurationException, com.ibm.wsspi.sibx.mediation.MediationBusinessException
		 */
		/**
		 * GENERATED COMMENT - DO NOT MODIFY
		 * Variables:  for output terminals - out (com.ibm.wsspi.sibx.mediation.OutputTerminal)
		 *             for user properties - <No user properties defined>
		 * Inputs:     inputTerminal (com.ibm.wsspi.sibx.mediation.InputTerminal), smo (com.ibm.websphere.sibx.smobo.ServiceMessageObject)
		 * Exceptions: com.ibm.wsspi.sibx.mediation.MediationConfigurationException, com.ibm.wsspi.sibx.mediation.MediationBusinessException
		 */

		PropertyLoader propLoader = new PropertyLoader();
		String[] columnNames = propLoader.getColumnNames();
		String tableName = propLoader.getTableName();
		DataObject POIListBGResult = ((DataObject) smo).getDataObject("body")
				.getDataObject("retrieveallgetPOIListBGResponse");
		DataObject POIListBGOutput = POIListBGResult
				.getDataObject("retrieveallgetPOIListBGOutput");

		ServiceManager serviceManager = new ServiceManager();
		QName qName = new QName("http://MAAdapterLib/IIFMAHSDAAdapter",
				"getListOfItemIdsResponseMsg");
		ServiceMessageObjectFactory smoFactory = ServiceMessageObjectFactory.eINSTANCE;
		ServiceMessageObject responseSMO = smoFactory
				.createServiceMessageObject(qName);
		BOFactory boFactory = (BOFactory) serviceManager
				.locateService("com/ibm/websphere/bo/BOFactory");

		DataObject getResponse = boFactory.createByElement(
				"http://MAAdapterLib/IIFMAHSDAAdapter",
				"getListOfItemIdsResponse");
		Vector list = new Vector();

		List poiList = POIListBGOutput.getList("getPOIList");
		if (poiList != null) {
			for (int i = 0; i < poiList.size(); i++) {
				DataObject poi = (DataObject) poiList.get(i);
				String wellid = poi.getString("wellid");
				System.out.println("POI from Datasource *******" + wellid);
				if (columnNames != null) {
					for (int j = 0; j < columnNames.length; j++) {
						list.add(wellid.trim() + "##" + tableName.toUpperCase()
								+ "##" + columnNames[j].toUpperCase());
					}
				} else {
					System.out
							.println("There is no column Names in the Properties");
				}

			}

		}

		DataObject simpleOut = (DataObject) boFactory.create(
				"http://MAAdapterLib", "ItemIdList");
		simpleOut.setList("ItemIds", list);
		getResponse.setDataObject("itemIds", simpleOut);
		//responseSMO.setBody(getResponse);
		((DataObject) responseSMO.getBody()).set(0, getResponse);
		out.fire(responseSMO); // propagate the service message object to the primitive that is wired to the 'out' terminal
	}
}
