/**
* (C)Copyright IBM Corp. 2010
* ALL RIGHTS RESERVED
*/


package com.ibm.iif.mediation;

import java.io.File;
import java.util.Map;

import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.ibm.wsspi.sib.exitpoint.ra.HashMap;

public class XMLParser {
	
	private static final String copyWriteStmt = "/** \n\t * (C)Copyright IBM Corp. 2010 \n\t * ALL RIGHTS RESERVED \n\t */";
	public static Map xmlData=new HashMap();
	static{
	loadXML("MediationXML.xml", false);	
	}
	public XMLParser() {
		
		}
	
	
	private static void loadXML(String filename, boolean validating){
		try{
			System.out.println("Loading Data");
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		factory.setValidating(validating);

//		 Create the builder and parse the file
		Document doc = factory.newDocumentBuilder().parse(new File(filename));
		if(doc==null){
			System.out.println("File MediationXML.xml cannot be found");
		}
	
		Node node=null;
		org.w3c.dom.NodeList tagNodeList = doc.getElementsByTagName("TAGList");
		NodeList tagNodes=tagNodeList.item(0).getChildNodes();
		Node tagNode=null,schemaNode=null;
		String id=null;
		String columnName=null;
		String tableName=null;
		String wherecls=null;
		for(int i=1;i<tagNodes.getLength();i=i+2){
			tagNode=tagNodes.item(i);
			id=tagNode.getAttributes().getNamedItem("id").getNodeValue();
			System.out.println(id);
		    schemaNode=tagNode.getChildNodes().item(1);
		    columnName = schemaNode.getAttributes().getNamedItem("column").getNodeValue();
		    tableName=schemaNode.getAttributes().getNamedItem("table").getNodeValue();
			wherecls=createWhereClause(tagNode);
			TagDO tagDO=new TagDO();
			tagDO.setColumnName(columnName);
			tagDO.setTableName(tableName);
			tagDO.setWhereClause(wherecls);
			System.out.println("XMLData Entry: "+tagDO);
			xmlData.put(id, tagDO);
		}
		
	
		} catch (Exception e) {
//		 A parsing error occurred; the xml input is not valid
			System.out.println("Exception in XML Parser "+e);
		} 
		
	
	}

	private static String createWhereClause(Node tagNode){
		String whereClause=" ";
		NodeList whereClauseNodes=tagNode.getChildNodes();
		for(int i=3;i<whereClauseNodes.getLength();i=i+2){
			if(i!=3){
				whereClause=whereClause+" and ";
			}
			NamedNodeMap attribute=whereClauseNodes.item(i).getAttributes();
			String type=attribute.getNamedItem("type").getNodeValue();
			String name=attribute.getNamedItem("name").getNodeValue();
			if(type.equalsIgnoreCase("simple")){
				whereClause=whereClause+ simpleWhereCls(whereClauseNodes.item(i));
			}
			else if(type.equalsIgnoreCase("complex")){
				whereClause=whereClause+ complexWhereCls(whereClauseNodes.item(i));
				
			}
			
			
		}
		return whereClause;
	}
		private static String simpleWhereCls(Node whereClauseNode){
			String whereClause=" ";
			NamedNodeMap attribute=whereClauseNode.getAttributes();
			String name=attribute.getNamedItem("name").getNodeValue();
			String value=attribute.getNamedItem("value").getNodeValue();
			String operation=attribute.getNamedItem("operation").getNodeValue();
			String encloseInQuotes=attribute.getNamedItem("encloseInQuotes").getNodeValue();
			if(encloseInQuotes.equalsIgnoreCase("yes"))
				whereClause=name+" "+operation+" '"+value+"'";
			else
				whereClause=name+" "+operation+" "+value+"";
			
			return whereClause;
		}
		private static String complexWhereCls(Node whereclauseNode){
			String whereClause=null;
			String name=whereclauseNode.getAttributes().getNamedItem("name").getNodeValue();
			Node queryNode=whereclauseNode.getChildNodes().item(1);
			NamedNodeMap attribute=queryNode.getAttributes();
			String query=attribute.getNamedItem("query").getNodeValue();
			whereClause=name+"=("+query+" where ";
			Node whereClsNode=queryNode.getChildNodes().item(1);
			String type=whereClsNode.getAttributes().getNamedItem("type").getNodeValue();
			if(type.equalsIgnoreCase("simple")){
				whereClause=whereClause+simpleWhereCls(whereClsNode);
			}
			else if(type.equalsIgnoreCase("complex")){
				whereClause=whereClause+complexWhereCls(whereClsNode);
			}
			whereClause=whereClause+")";
			return whereClause;
		}
	public TagDO getTagDO(String id){
		return (TagDO) xmlData.get(id);
	}
	
	public static void main(String[] args) {
	XMLParser xmlparser=new XMLParser();
	TagDO tagDo=xmlparser.getTagDO("6410/12-1_CHOKE_OPENING");
	System.out.println(tagDo);
	
}
}
