CREATE TABLE MM.CLIENTADAPTERS (
		ADAPTERID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ENDPOINT VARCHAR(1024) NOT NULL,
		CONSTRAINT PK_MMDB_LIST87 PRIMARY KEY (ADAPTERID),
		CONSTRAINT PK_MMDB_UNQ87 UNIQUE (NAME)
	);
	
CREATE TABLE MM.SERVERADAPTERPROFILES (
		PROFILEID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ISDEFAULT SMALLINT,
		ADAPTERID INTEGER NOT NULL,
		CONSTRAINT PK_MMDB_LIST81 PRIMARY KEY (PROFILEID),
		CONSTRAINT PK_MMDB_UNQ81 UNIQUE (ADAPTERID, NAME)
	);

CREATE TABLE MM.SERVERADAPTERS (
		ADAPTERID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		ENDPOINT VARCHAR(1024) NOT NULL,
		TYPE VARCHAR(10) NOT NULL,
		CONSTRAINT PK_MMDB_LIST83 PRIMARY KEY (ADAPTERID),
		CONSTRAINT PK_MMDB_UNQ83 UNIQUE (ENDPOINT),
		CONSTRAINT PK_MMDB_UNQ83A UNIQUE (NAME)
	);


CREATE TABLE MM.SUBUNIT (
		SUBUNITID INTEGER NOT NULL,
		NAME VARCHAR(255) NOT NULL,
		SUBDIRECTORY VARCHAR(255) NOT NULL,
		ATTACHPOINT VARCHAR(255),
		LASTIMPORTED VARCHAR(1024),
		CONVERSIONENDPOINT VARCHAR(1024),
		INCREMENTALFILES SMALLINT DEFAULT 0,
		CONSTRAINT PK_MMDB_LIST85 PRIMARY KEY (SUBUNITID),
		CONSTRAINT PK_MMDB_UNQ85 UNIQUE (NAME),
		CONSTRAINT PK_MMDB_UNQ85A UNIQUE (SUBDIRECTORY)
	);

CREATE TABLE MM.SUBUNIT_CA (
		SUBUNITID INTEGER NOT NULL,
		ADAPTERID INTEGER NOT NULL
	);
	
CREATE TABLE MM.SUBUNIT_SA (
		SUBUNITID INTEGER NOT NULL,
		ADAPTERID INTEGER NOT NULL,
		PROFILEID INTEGER NOT NULL
	);




ALTER TABLE MM.SERVERADAPTERPROFILES ADD CONSTRAINT SERVERADAP_SERV_FK FOREIGN KEY (ADAPTERID) REFERENCES MM.SERVERADAPTERS (ADAPTERID) ON DELETE CASCADE;

ALTER TABLE MM.SUBUNIT_CA ADD CONSTRAINT SUBCA__SUBUN_FK FOREIGN KEY (SUBUNITID) REFERENCES MM.SUBUNIT (SUBUNITID) ON DELETE CASCADE;

ALTER TABLE MM.SUBUNIT_CA ADD CONSTRAINT SUBCA_CLIENTADA_FK FOREIGN KEY (ADAPTERID) REFERENCES MM.CLIENTADAPTERS (ADAPTERID) ON DELETE CASCADE;

ALTER TABLE MM.SUBUNIT_SA ADD CONSTRAINT SUBUNIT__SUBUN_FK FOREIGN KEY (SUBUNITID) REFERENCES MM.SUBUNIT (SUBUNITID) ON DELETE CASCADE;

ALTER TABLE MM.SUBUNIT_SA ADD CONSTRAINT SUBUN_SERVERADA_FK FOREIGN KEY (ADAPTERID) REFERENCES MM.SERVERADAPTERS (ADAPTERID) ON DELETE CASCADE;

ALTER TABLE MM.SUBUNIT_SA ADD CONSTRAINT SUBU_SERVERADAP_FK FOREIGN KEY (PROFILEID) REFERENCES MM.SERVERADAPTERPROFILES (PROFILEID) ON DELETE CASCADE;



CREATE SEQUENCE MM.SRVADPTP_SEQ START WITH 1 INCREMENT BY 1 NOMAXVALUE;
CREATE SEQUENCE MM.SUBUNIT_SEQ START WITH 1 INCREMENT BY 1 NOMAXVALUE;
CREATE SEQUENCE MM.SRVADPTR_SEQ START WITH 1 INCREMENT BY 1 NOMAXVALUE;
CREATE SEQUENCE MM.CLNTADPT_SEQ START WITH 1 INCREMENT BY 1 NOMAXVALUE;

CREATE OR REPLACE TRIGGER MM.SRVADPTP_TRIGGER 
BEFORE INSERT ON MM.SERVERADAPTERPROFILES FOR EACH ROW
  BEGIN
    SELECT  MM.SRVADPTP_SEQ.NEXTVAL INTO :new.PROFILEID FROM dual;
  END;
/

CREATE OR REPLACE TRIGGER MM.SUBUNIT_TRIGGER 
BEFORE INSERT ON MM.SUBUNIT FOR EACH ROW
  BEGIN
    SELECT  MM.SUBUNIT_SEQ.NEXTVAL INTO :new.SUBUNITID FROM dual;
  END;
/

CREATE OR REPLACE TRIGGER MM.SRVADPTR_TRIGGER 
BEFORE INSERT ON MM.SERVERADAPTERS FOR EACH ROW
  BEGIN
    SELECT  MM.SRVADPTR_SEQ.NEXTVAL INTO :new.ADAPTERID FROM dual;
  END;
/

CREATE OR REPLACE TRIGGER MM.CLNTADPT_TRIGGER 
BEFORE INSERT ON MM.CLIENTADAPTERS FOR EACH ROW
  BEGIN
    SELECT  MM.CLNTADPT_SEQ.NEXTVAL INTO :new.ADAPTERID FROM dual;
  END;
/

INSERT INTO MM.SUBUNIT (NAME, SUBDIRECTORY) VALUES ('DEFAULT', '.');

COMMIT;
exit