@echo off
setlocal

REM ************************************************
REM         User Defined Variables
REM ************************************************

REM SID name for IIC1.4
SET SID=IICDB

REM Password used for all users created by IIC1.4 database scripts
SET USER_PWD=@DATABASE_PWD@

REM ************************************************
REM         Main
REM ************************************************

set TABLE_SCRIPTS_ROOT=%~dp0
set CURRENT_DRIVE=%~d0
SET LOG_FILE="%TABLE_SCRIPTS_ROOT%output.log"


REM Defect fix: runTableScripts.bat in db scripts in IIC1.4 GM build fails to run the ppbParameterLoad.ctl due to incorrect file path
REM New requirement: PPBParametersOut.txt has changed
REM ppbParameterLoad
set TASK_DESC=Loading PPB Parameters...
echo %TASK_DESC% | echo %TASK_DESC% >> %LOG_FILE%
set CALL_STRING=sqlldr PPB/%USER_PWD%@%SID% control="%TABLE_SCRIPTS_ROOT%Parameters\ppbParameterLoad.ctl"
echo %CALL_STRING% | echo %CALL_STRING% >> %LOG_FILE%
%CURRENT_DRIVE%
cd %TABLE_SCRIPTS_ROOT%Parameters
call %CALL_STRING% >> %LOG_FILE%

REM For 1401 *********************************************************
REM New requirement: MM tables has changed
set TASK_DESC=Updating MM Tables...
echo %TASK_DESC% | echo %TASK_DESC% >> %LOG_FILE%
set CALL_STRING=sqlplus -S MM/%USER_PWD%@%SID% @"%TABLE_SCRIPTS_ROOT%MM\updateMMDBTables.sql"
echo %CALL_STRING% | echo %CALL_STRING% >> %LOG_FILE%
call %CALL_STRING% >> %LOG_FILE%

REM For 1401 *********************************************************
REM New requirement: MASADB tables has changed
set CALL_STRING=sqlplus -S MASADB/%USER_PWD%@%SID% @"%TABLE_SCRIPTS_ROOT%MASA\updateMASADBTables.sql"
echo %CALL_STRING% | echo %CALL_STRING% >> %LOG_FILE%
call %CALL_STRING% >> %LOG_FILE%
